Module
Core API

Module interface. More...

## Files

file | module.h
| `pipewire/module.h`

## Data Structures

struct | pw_module_info
| The module information. More...
struct | pw_module_events
| Module events. More...
struct | pw_module_methods
| Module methods. More...
struct | pw_module

## Macros

#define | PW_TYPE_INTERFACE_Module PW_TYPE_INFO_INTERFACE_BASE "Module"
#define | PW_VERSION_MODULE 3
#define | PW_MODULE_CHANGE_MASK_PROPS (1 << 0)
#define | PW_MODULE_CHANGE_MASK_ALL ((1 << 1)-1)
#define | PW_MODULE_EVENT_INFO 0
#define | PW_MODULE_EVENT_NUM 1
#define | PW_VERSION_MODULE_EVENTS 0
#define | PW_MODULE_METHOD_ADD_LISTENER 0
#define | PW_MODULE_METHOD_NUM 1
#define | PW_VERSION_MODULE_METHODS 0
#define | pw_module_method(o, method, version, ...)
#define | pw_module_add_listener(c, ...) pw_module_method(c,add_listener,0,__VA_ARGS__)

## Functions

struct pw_module_info * | pw_module_info_update (struct pw_module_info *info, const struct pw_module_info *update)
| Update and existing pw_module_info with update with reset. More...
struct pw_module_info * | pw_module_info_merge (struct pw_module_info *info, const struct pw_module_info *update, bool reset)
| Merge and existing pw_module_info with update. More...
void | pw_module_info_free (struct pw_module_info *info)
| Free a pw_module_info. More...

## Detailed Description

Module interface.

## Macro Definition Documentation

## PW_TYPE_INTERFACE_Module

#define PW_TYPE_INTERFACE_Module PW_TYPE_INFO_INTERFACE_BASE "Module"

## PW_VERSION_MODULE

#define PW_VERSION_MODULE 3

## PW_MODULE_CHANGE_MASK_PROPS

#define PW_MODULE_CHANGE_MASK_PROPS (1 << 0)

## PW_MODULE_CHANGE_MASK_ALL

#define PW_MODULE_CHANGE_MASK_ALL ((1 << 1)-1)

## PW_MODULE_EVENT_INFO

#define PW_MODULE_EVENT_INFO 0

## PW_MODULE_EVENT_NUM

#define PW_MODULE_EVENT_NUM 1

## PW_VERSION_MODULE_EVENTS

#define PW_VERSION_MODULE_EVENTS 0

## PW_MODULE_METHOD_ADD_LISTENER

#define PW_MODULE_METHOD_ADD_LISTENER 0

## PW_MODULE_METHOD_NUM

#define PW_MODULE_METHOD_NUM 1

## PW_VERSION_MODULE_METHODS

#define PW_VERSION_MODULE_METHODS 0

## pw_module_method

#define pw_module_method | ( |  | o,
|  |  | method,
|  |  | version,
|  |  | ...
| ) |  |

## pw_module_add_listener

#define pw_module_add_listener | ( |  | c,
|  |  | ...
| ) |  | pw_module_method(c,add_listener,0,__VA_ARGS__)

See also
  pw_module_methods.add_listener

## Function Documentation

## pw_module_info_update()

struct pw_module_info* pw_module_info_update | ( | struct pw_module_info * | info,
|  | const struct pw_module_info * | update
| ) |  |

Update and existing pw_module_info with update with reset.

## pw_module_info_merge()

struct pw_module_info* pw_module_info_merge | ( | struct pw_module_info * | info,
|  | const struct pw_module_info * | update,
|  | bool | reset
| ) |  |

Merge and existing pw_module_info with update.

## pw_module_info_free()

void pw_module_info_free | ( | struct pw_module_info * | info | ) |

Free a pw_module_info.